<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_INC_CACHE")) return;
define("_INC_CACHE", "1");
include_ecrire('inc_serialbase.php3');

function squelette_obsolete($naissance, $vetuste)
{
  // vrif de la date de validit par rapport  la source
  // (ici le champ VETUSTE) et les fonctions agissant sur le compilateur
  // (celui-ci est suppos ne changer qu' l'installation)

  return (($GLOBALS['recalcul_squelettes'] == 'oui')
	  OR ((filemtime($vetuste) > $naissance)
	      OR ((file_exists("ecrire/mes_options.php3")
		   AND (filemtime("ecrire/mes_options.php3") > $naissance)))
	      OR ((file_exists("mes_fonctions.php3")
		  AND (filemtime("mes_fonctions.php3") > $naissance)))));
}

function page_obsolete($naissance, $vetuste)
{
  global $lastmodified; // pour l'entete HTTP homonyme
  // Inclusions multiples : derniere modification --- a verifier
  if ($lastmodified < $naissance) $lastmodified = $naissance;

  // vrif de la date de validit par rapport  la dure de vie

  return ((time() > ($naissance + $vetuste)) and (!timeout(false,false)));
}

function cv_du_cache($hache)
{
      $r = spip_fetch_array(spip_query("
SELECT	naissance
FROM	spip_caches
WHERE	hache = 0x$hache"));
      return $r['naissance']; 
}

function ramener_cache($cache, $obsolete, $table, $dodo=0)
{
  // attendre son tour
  while (!spip_get_lock($cache, 1)); 

  //cache dj compil ?
  $r = spip_fetch_array(spip_query("
SELECT texte,naissance,vetuste
FROM $table
WHERE hache = 0x$cache"));
  if (!$r)
    { 
#      spip_log("$cache absent");
      // Non. On annonce qu'on s'en occupe en le declarant d'age nul
      // On met aussi un texte standard pour que l'internaute sache quoi
      // faire en cas de pb (ne devrait pas arriver cependant)
      spip_query("
INSERT INTO $table (hache, naissance, texte)
VALUES (0x$cache, 0, 'Si votre navigateur affiche ce message, c\'est que $table est incomplte, suite  la disparition du processus " . getmypid() . ". Ressayez')");
    } else {
      // Oui, mais quel est son age ?
      $t = $r['naissance'];
      // age nul ==> un autre processus fait le boulot en ce moment.
      // Si ce perdant de PHP connaissait Waitpid, j'aurais pu synchroniser.
      // L je suis oblig de dormir 1 seconde systmatiquement
      // et d'estimer que s'il n'y a rien de neuf au rveil, 
      // c'est que le processus est mort et ne finira pas le boulot.
      // Avec un rendez-vous j'aurais meme pu augmenter la priorit du cache.
      if (!$t && !$dodo)
	{
	  spip_release_lock($cache);
	  sleep(1);
	  return ramener_cache($cache, $obsolete, $table, 1);
	}
      // test de vtust du cache ou de processus concurrent dcd
      if ($dodo || ($obsolete($t, $r['vetuste'])))
	{  // trop vieux ! ramener son age  0 cf ci-dessus
	  spip_query("
UPDATE	$table
SET	naissance=0, texte=" . getmypid() . "
WHERE	hache=0x$cache");
	  $r = '';
	} else 
	  {
	    $r = $r['texte'];
#	    spip_log("$obsolete prsent" . strlen($r));
	  }
    }
  spip_release_lock($cache);
  return $r;
}

function ramener_squelette($squelette)
{
  // L'valuation du squelette definit les fonctions associees aux boucles,
  // et fournit le nom de la fonction principale

  $c = md5($squelette);
  eval(ramener_cache($c, 'squelette_obsolete', 'spip_squelettes'));

  if (!$func_squelette_executer) {

    // Cache absent, effac ou erron ==> compilation
    // L'internaute s'impatientant, cacher en priorit basse, 

    include_local("inc-calcul-squel.php3");
    $timer_a = explode(" ", microtime());
    $r = calculer_squelette($squelette);
    $timer_b = explode(" ", microtime());
    $timer = ceil(1000*($timer_b[0] + $timer_b[1]-$timer_a[0]-$timer_a[1]));
    spip_log("Crer ($timer ms): $squelette " . strlen($r));
    // pour la mise au point
    if (file_exists("ecrire/data/.skeldif")) 
      {$f=fopen("ecrire/data/.skeldif", "a"); 
       fwrite($f,"\n############skeldif $c :$squelette\n");
       fwrite($f,$r);
       fclose($f);}
    spip_query("
UPDATE	LOW_PRIORITY spip_squelettes
SET	naissance=UNIX_TIMESTAMP(), 
	vetuste='" . $squelette . ".html',
	texte='" . addslashes($r) . "'
WHERE	hache=0x$c
");
    eval($r);
  }
  return $func_squelette_executer;
}

function ecrire_cache($appel, $cache, $page, $infosurpage, $delais) {
  //  if ($delais &&  empty($HTTP_POST_VARS))
    {
      // pour la mise au point
      if (file_exists("ecrire/data/.cachedif")) 
	{$f=fopen("ecrire/data/.cachedif", "a"); 
	fwrite($f,"\n############skeldif $cache :$appel\n");
	fwrite($f,$page);
	fclose($f);}
      // Comme pour les squelettes, cache diffr pour calmer l'impatience
#      spip_log("$cache cre $delais");
       spip_query("
UPDATE	LOW_PRIORITY spip_caches 
SET	naissance=UNIX_TIMESTAMP(),
	texte='" . addslashes($page) . "',
	vetuste= " . $delais . "
WHERE	hache=0x$cache
");
    }
  // pour l'instant on ne sait traiter que ces infos-l:
    invalideur_de_cache(&$infosurpage, 'id_article', $cache);
    invalideur_de_cache(&$infosurpage, 'id_breve', $cache);
    invalideur_de_cache(&$infosurpage, 'id_rubrique', $cache);
}

function invalideur_de_cache($a, $type, $cache) {
  if (is_array($a[$type]))
    {
      $values = array();
      foreach($a[$type] as $k => $v)
	{ $m = "(0x$cache, $k)"; $values[] = $m; $l .= $m;}
      spip_log("cache de type $type: $l");
      spip_query("
INSERT IGNORE INTO spip_" . $type . _SUFFIXE_DES_CACHES . "
(hache, " . $type . ")
VALUES " . join(", ", $values));
    }
}

// Regarde dans une table de nom de caches ceux vrifiant une condition donne
// Les retire de cette table et de la table gnrale des caches

function update_cache($cond, $table)
{
  global $spip_tables_principales;
  spip_log("update_cache: $cond $table");
  $result = spip_query("
SELECT  DISTINCT hache 
FROM    $table" . (!$cond ? '' : "
WHERE   $cond
"));
  $tous = '';
  while ($row = spip_fetch_array($result)) $tous[] = $row['hache'];
  if ($tous) {
    $tous = join(', ', $tous);
    spip_log("$tous dtruits");
      spip_query("
DELETE FROM spip_caches
WHERE hache IN ($tous)
");
      foreach($spip_tables_principales as $a)
	{
	  spip_query("
DELETE FROM spip_" . $GLOBALS[$a . '_key']["PRIMARY KEY"] . _SUFFIXE_DES_CACHES ."
WHERE hache IN ($tous)
");
	}
  }
}
?>
