<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_INC_CHERCHE")) return;
define("_INC_CHERCHE", "1");

//
// Recherche recursive du squelette
//

function chercher_squelette_hierarchie($fond, $id_rubrique, $dossier='') {
	if (!$id_rubrique) {
		if (@file_exists("$dossier$fond.html")) {
			return "$dossier$fond";
		} else if (@file_exists("$fond.html")) {
			return "$fond";
		} else if (@file_exists("$fond-dist.html")) {
			return "$fond-dist";
		} else {
			// erreur webmaster : $fond ne correspond a rien
			include_ecrire ("inc_presentation.php3");
			install_debut_html("Erreur sur le site");
			echo "<P>Aucun squelette <b>$dossier$fond</b> n'est disponible...</P>";
			install_fin_html();
			spip_log ("ERREUR: aucun squelette $dossier$fond n'est disponible...");
			exit;
		}
	}
	else {
		if (file_exists("$dossier$fond-$id_rubrique.html")) {
			return "$dossier$fond-$id_rubrique";
		} else {
			$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique='$id_rubrique'";
			$result = spip_query($query);
			while($row = spip_fetch_array($result)) {
				$id_parent=$row['id_parent'];
			}
			return chercher_squelette_hierarchie($fond, $id_parent, $dossier);
		}
	}
}

function chercher_squelette($fond, $id_rubrique) {
	global $dossier_squelettes;

	// prendre en compte le bon repertoire (pas grave si on a deux / dans l'arborescence)
	$dossier = ($dossier_squelettes ? $dossier_squelettes.'/' : '');

	// On selectionne, dans l'ordre :
	// fond=10.html, fond-10.html, fond-<rubriques parentes>.html, fond.html puis fond-dist.html
	if (($id_rubrique > 0) AND (file_exists("$dossier$fond=$id_rubrique.html"))) {
		return "$dossier$fond=$id_rubrique";
	}
	else {
		return chercher_squelette_hierarchie($fond, $id_rubrique, $dossier); // recursif le long de la hierarchie
	}
}

function cherche_page($fond, $cache, $contexte, $rech='', $lang='', $id_r='') 
{
  static $fonctions_squelettes = '';

  include_local("inc-calcul.php3");

  $fond = chercher_squelette($fond, $id_r ? $id_r : $contexte['id_rubrique']);
  if ($lang)
    {
	lang_select($lang);
	if (@file_exists("$fond.$lang.html")) $fond = "$fond.$lang";
    }
  if (!$fonctions_squelettes[$fond])
    $fonctions_squelettes[$fond] =  ramener_squelette($fond);
  $timer_a = explode(" ", microtime());
  $page =  $fonctions_squelettes[$fond]($contexte, $cache);
  $timer_b = explode(" ", microtime());
  $timer = ceil(1000*($timer_b[0] + $timer_b[1] - $timer_a[0] - $timer_a[1]));
  $taille = ceil(strlen($page[0]) / 1024);
  spip_log("Crer: ($timer ms): $fond ($taille ko, cache: $cache)");
  if (!$rech)
    return $page;
  else {
    include_ecrire("inc_surligne.php3");
    spip_log("Recherche : $rech");
    return array(surligner_mots($page[0], $rech), $page[1]);
  } 
}

function calculer_page_globale($fond, $cache, $var_recherche) {
  global $contexte, $HTTP_GET_VARS;

	$contexte = '';
	$contexte_defaut = array('id_parent', 'id_rubrique', 'id_article', 'id_auteur',
		'id_breve', 'id_forum', 'id_secteur', 'id_syndic', 'id_syndic_article', 'id_mot', 'id_groupe', 'id_document');
	reset($contexte_defaut);
	while (list(, $val) = each($contexte_defaut)) {
		if ($HTTP_GET_VARS[$val]) {
			$contexte[$val] = intval($HTTP_GET_VARS[$val]);
		}
	}
	if ($GLOBALS['date'])
		$contexte['date'] = $contexte['date_redac'] = normaliser_date($GLOBALS['date']);
	else
		$contexte['date'] = $contexte['date_redac'] = date("Y-m-d H:i:s");

	$lang = lire_meta('langue_site');
	if ($contexte['lang'])
		$lang = $contexte['lang'];	// si inc-urls veut fixer la langue

	// Calcul de la rubrique associee a la requete
	// (selection de squelette specifique)

	if ($id = $contexte['id_rubrique']) {
		$id_rubrique_fond = $id;
		if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id'")))
			if ($row['lang']) $lang = $row['lang'];
	}
	else if ($id  = $contexte['id_breve']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique FROM spip_breves WHERE id_breve='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id_rubrique_fond'")))
				if ($row['lang']) $lang = $row['lang'];
		}
	}
	else if ($id = $contexte['id_syndic']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique FROM spip_syndic WHERE id_syndic='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id_rubrique_fond'")))
				if ($row['lang']) $lang = $row['lang'];
		}
	}
	else if ($id = $contexte['id_article']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique,lang FROM spip_articles WHERE id_article='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row['lang']) $lang = $row['lang'];
		}
	}
	else {
		$id_rubrique_fond = 0;
	}

	// Special stats et boutons admin
	reset($contexte_defaut);
	$signale_globals = "";
	while (list($key, $val) = each($contexte_defaut)) {
		if ($contexte[$val]) {
			$GLOBALS[$val] = $contexte[$val];
			$signale_globals .= '$GLOBALS[\''.$val.'\'] = '.intval($contexte[$val]).";";
		}
	}
	$page = cherche_page($fond, $cache, $contexte, $var_recherche, $lang, $id_rubrique_fond);
	return (!$signale_globals ? $page :
		array('<'."?php $signale_globals ?".'>'.$page[0], $page[1]));
}
?>
