<?php

// Retourne la requete SQL dtermine par les infos mises dans $boucles

function calculer_requete($id_boucle) {
 global $tables_relations, $table_primary, $table_des_tables, $table_date, $boucles;
 $boucle = &$boucles[$id_boucle];
 $type = $boucle->type_requete;
 $id_table = $table_des_tables[$type];
 $id_field = $id_table . "." . $table_primary[$type];
  switch($type) {
  case 'articles':
    $boucle->from[] = '$DB"."' . "_articles AS $id_table";
    if (lire_meta("post_dates") == 'non') {
      $boucle->where[] = "$id_table.date<NOW()";}
    $boucle->where[] = "$id_table.statut='publie'";
    break;

  case 'auteurs':
    $boucle->from[] = '$DB"."' . "_auteurs AS $id_table";
    // Si pas de lien avec un article, selectionner
    // uniquement les auteurs d'un article publie
    if (!$boucle->lien AND !$boucle->tout) {
      $boucle->from[] = '$DB"."' . "_auteurs_articles AS lien";
      $boucle->from[] = '$DB"."' . "_articles";
      $boucle->where[] = "lien.id_auteur=$id_table.id_auteur";
      $boucle->where[] = 'lien.id_article=$DB"."'."_articles.id_article";
      $boucle->where[] = '$DB"."' . "_articles.statut='publie'";
      $boucle->group = "\nGROUP BY " . $id_field;
    }
    // pas d'auteurs poubellises
    $boucle->where[] = "NOT($id_table.statut='5poubelle')";
    break;
    
  case 'breves':
    $boucle->from[] = '$DB"."' . "_breves AS $id_table";
    $boucle->where[] = "$id_table.statut='publie'";
    break;
    
  case 'forums':
    $boucle->from[] = '$DB"."' . "_forum AS $id_table";
    // Par defaut, selectionner uniquement les forums sans pere
    if (!$boucle->tout AND !$boucle->plat) 
      {
	$boucle->where[] = "$id_table.id_parent=0";
      }
    $boucle->where[] = "$id_table.statut='publie'";
   break;
    
  case 'signatures':
    $boucle->from[] = '$DB"."' . "_signatures AS $id_table";
    $boucle->from[] = '$DB"."' . "_petitions";
    $boucle->from[] = '$DB"."' . "_articles";
    $boucle->where[] = '$DB"."' . "_petitions.id_article=" . '$DB"."' . "_articles.id_article";
    $boucle->where[] = '$DB"."' . "_petitions.id_article=$id_table.id_article";
    $boucle->where[] = "$id_table.statut='publie'";
    $boucle->group = "\nGROUP BY " . $id_field;
    break;
    
  case 'documents':
    $boucle->from[] = '$DB"."' . "_documents AS $id_table";
    $boucle->from[] = '$DB"."' . "_types_documents AS types_documents";
    $boucle->where[] = "$id_table.id_type=types_documents.id_type";
    $boucle->where[] = "$id_table.taille > 0";
    break;
    
  case 'types_documents':
    $boucle->from[] = '$DB"."' . "_types_documents AS $id_table";
    break;
    
  case 'groupes_mots':
    $boucle->from[] = '$DB"."' . "_groupes_mots AS $id_table";
    break;
    
  case 'mots':
    $boucle->from[] = '$DB"."' . "_mots AS $id_table";
    $boucle->where[] = "$id_table.titre<>'kawax'";
    break;
    
  case 'rubriques':
    $boucle->from[] = '$DB"."' . "_rubriques AS $id_table";
    if (!$boucle->tout) $boucle->where[] = "$id_table.statut='publie'";
    break;
    
  case 'hierarchie':
    $boucle->from[] = '$DB"."' . "_rubriques AS $id_table";
    $boucle->where[] = 'rubriques.id_rubrique = $hierarchie';
    // champ oblig pour grer le 2e while synthtis dans inc-calcul-squel
    $boucle->select[] = "rubriques.id_parent";
    break;
    
  case 'syndication':
    $boucle->from[] = '$DB"."' . "_syndic AS $id_table";
    $boucle->where[] = "$id_table.statut='publie'";
    break;
    
  case 'syndic_articles':
    $boucle->from[] = '$DB"."' . "_syndic_articles  AS $id_table";
    $boucle->from[] = '$DB"."' . "_syndic AS syndic";
    $boucle->where[] = "$id_table.id_syndic=syndic.id_syndic";
    $boucle->where[] = "$id_table.statut='publie'";
    $boucle->where[] = "syndic.statut='publie'";
    $boucle->select[]='syndic.nom_site AS nom_site'; # drogation zarbi
    $boucle->select[]='syndic.url_site AS url_site'; # idem
    break;
  } // fin du switch


  $s = "\nSELECT\t". # si pas de champ ca doit etre juste un dcompte
	((!$boucle->select) ? $id_field  : 
	 join(",\n\t", array_unique($boucle->select))) ;
  $f = "\nFROM\t".
       join(",\n\t", array_unique($boucle->from)) .
       ((!$boucle->where) ? "" : 
	("\nWHERE\t".join("\n AND\t", array_unique($boucle->where)))) .
       $boucle->group .
       $boucle->order .
       ((!$boucle->limit) ? "" : ("\nLIMIT\t".$boucle->limit));
  if (!$boucle->sous_requete)
    return ($s . $f) ;
  else return
	 ("\nSELECT\tS_" . 
	  ((!$boucle->select) ? $id_field  : 
	  join(",\n\tS_", array_unique($boucle->select))) .
	 "\nFROM ($s,\n\tCOUNT(" . $boucle->sous_requete .
	 ") AS compteur $f)\n AS S_$id_table\nWHERE compteur= " . 
	  $boucle->compte_requete);
}

?>
